/*  factors.c -- Find factors of a given number							*
*   Compile with tigcc and link longdiv.o and longmul.o:		*
*   >tigcc factors.c -O2 longdiv.o longmul.o								*
*   The two object files should be in the same directory as	*
*   factors.c  They can be found in the /patches directory	*
*   if you installed tigcc correctly.												*
*   Any questions, comments or ideas can be e-mailed to me	*
*   mikegrass@techie.com																		*
*																														*
*   Mike Grass																							*/

#define RETURN_VALUE

#include <nostub.h>
#include <args.h>
#include <string.h>
#include <graph.h>
#include <statline.h>
#include <kbd.h>
#include <estack.h>


int _ti89,_ti92plus;		//Compile for the 89 and 92 plus

void _main(void) 
{
  ESI argptr;							//Declare needed variables
  int argtype, bufferIndex=1;			//
  register unsigned long num asm("a5");			//
  unsigned long factor_buffer[500], k=0;

/*Initialize some stuff*/
  InitArgPtr(argptr);	//Initialize the argument pointer; needed to get the argument

/*Check that the argument is valid*/
  if((argtype = GetArgType(argptr)) == END_TAG || argtype!=POSINT_TAG)
  {
    ST_helpMsg("Error! Usage: factors(num)");
    push_END_TAG();
    push_quantum_pair(0x01,0xEC);
    return 0;					//Aborts the program, errormsg in status line
  }

  else  //We have a valid argument, continue execution
  {
    num=(unsigned long)GetIntArg(argptr);  //extract the argument into variable num
    push_END_TAG();	//OS works in RPN, so we have to push the END_TAG first
    push_longint(num);	//right now, if num is greater than 2^32/2-1, the calc will wrap the number around because it is only a long
    
    for(k=2; k<(unsigned int)(num/k); k++)		//k should never reach num (unless num is 1 or 2)
    {

     if(num % k == 0)		//check if k is a factor of num
      {

	if(bufferIndex>1)	//make sure that we aren't causing an error
	{

	  if((factor_buffer[bufferIndex-1]*k)==num)	//if previous found factor * current factor == num,
	  {						//we have found the midpoint and don't need to

	    break;					//keep searching for factors, because all of 

	  }						//the rest of the factors will be

	}						//num/factor_buffer[k] from current k to 1

	factor_buffer[bufferIndex]=k;  //add the current factor to the buffer
	bufferIndex+=1;		//update the buffer index

	if(k*k==num)    //check to see if k^2==num, we are at the midpoint of factors
	{
	  bufferIndex-=1;  //correct the index
	  break;
	}

      }

    }

/*Find the other factors from the factor_buffer by dividing num by factor_buffer[k]*/
    for(k=bufferIndex-1;k>=1;k--)  
    {
//      lNum=num/factor_buffer[k];	//find the factor from the factor_buffer	
//      push_longint(lNum);	//push factor onto the stack
      factor_buffer[bufferIndex++]=num/factor_buffer[k];
    }
    for(k=bufferIndex-1;k>=1;k--)
    {
      push_longint(factor_buffer[k]);
    }
    push_longint(1);	//all integers have factors of 1
    push_LIST_TAG();//tell the OS that we have pushed a list on the stack
  }
  return 0;  
}
